package com.galaxis.manatee.Test;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunDayLog;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import lombok.Data;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

@SpringBootTest
public class updateDayWorkHour {

    private ChuanYunManager chuanYunManager;

    @Autowired
    public void setChuanYunManager(ChuanYunManager chuanYunManager) {
        this.chuanYunManager = chuanYunManager;
    }

    @Test
    void updateDayWorkHourProjectId() {
        ObjectMapper objectMapper = new ObjectMapper();
        List<String> m = List.of("project_2,2e3018f9-8ab7-11ea-8ae9-7cd30ab711fe", "projecttype_2,实施");
        //从氚云查询数据
        var filter = Filter.instance(0, 100, true, Filter.AND, m);
        ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
        try {
            chuanyunFindAllResponse = chuanYunManager.findAll("D001789DayLog", filter);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        if (chuanyunFindAllResponse.getReturnData() == null) {
            return;
        }
        //转化为POJO
        List<ChuanyunDayLog> result = objectMapper.convertValue(chuanyunFindAllResponse.getReturnData().getBizObjectArray(), new TypeReference<>() {
        });

        result.forEach(chuanyunDayLog -> {
            UpdateProjectIdDTO updateProjectIdDTO = new UpdateProjectIdDTO("1f48d45f-10bf-4b26-ad5a-9f0e41ad02ef");
            try {
                String jsonStr = objectMapper.writeValueAsString(updateProjectIdDTO);
                chuanYunManager.update("D001789DayLog",chuanyunDayLog.getObjectId(),jsonStr);
            } catch (Exception e) {
                e.printStackTrace();
            }
        });


    }

    @Data
    class UpdateProjectIdDTO {

        @JsonProperty("project")
        private String project;

        public UpdateProjectIdDTO(String project) {
            this.project = project;
        }
    }

}
